@echo OFF
@if not "%ECHO%"=="" echo %ECHO%
@if not "%OS%"=="Windows_NT" goto DOSEXIT
rem $Workfile: uncback.bat $ $Revision: 2 $ $Date: 12/04/97 9:51a $
rem $Archive: /TimH/Pubs/Books/Macmillan/Windows NT Scripting/Scripts/uncback.bat $

rem Set local scope and call MAIN procedure
setlocal & pushd & set RET=
	set SCRIPTNAME=%~n0
	set SCRIPTPATH=%~f0
	if "%DEBUG%"=="1" (set TRACE=echo) else (set TRACE=rem)
	call _mtplib :INIT %SCRIPTPATH%
	if /i {%1}=={/help} (call :HELP %2) & (goto :HELPEXIT)
	if /i {%1}=={/?} (call :HELP %2) & (goto :HELPEXIT)
	call :MAIN %*
	:HELPEXIT
popd & endlocal & set RET=%RET%
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem HELP procedure
rem Display brief on-line help message
rem
:HELP
if defined TRACE %TRACE% [proc %0 %*]
	echo Syntax: UNCBACK [dir-list] [switches]
	echo Invokes NTBACKUP for the specified dir-list.
	echo .
	echo All switches at the end of the command line are passed unaltered to
	echo NTBACKUP. The contents of the NTBACKUPSW variable is prefixed before
	echo these switches.
	echo .
	echo Directory names in the dir-list can be UNC names, which are mapped
	echo to drive letters for the duration of the backup operation.
	echo .
	echo Example:
	echo     UNCBACK C:\ D:\ \\SERVER\FILES1 /A /B /V
goto :EOF


rem /////////////////////////////////////////////////////////////////////////
rem MAIN procedure
rem
rem Arguments:	path(s)=path names to backup (incl. UNC names)
rem		/...=first switch marks start of switches passed to NTBACKUP
rem		NTBACKUPSW=additional switches passed before cmdline ones
rem 
:MAIN
if defined TRACE %TRACE% [proc %0 %*]
	rem If no arguments, we default to displaying help
	if {%1}=={} (call :HELP) & (goto :EOF)

	rem Clear variables
	set PATHLIST=
	set SWITCHLIST=
	set /a UNCCOUNT=0

	rem Build list of paths, mapping UNC names
	:PATHLISTLOOP
		if {%1}=={} goto :PATHLISTLOOPEND
		set T1=%1
		set T1=%T1:"=%
		if "%T1:~0,1%"=="/" goto :PATHLISTLOOPEND
		if "%T1:~0,1%"=="-" goto :PATHLISTLOOPEND
		if "%T1:~0,2%"=="\\" (
			(pushd "%T1%")
			(set /a UNCCOUNT+=1)
			(for /f "tokens=*" %%I in ('cd') do set T1=%%I)
		)
		set PATHLIST=%PATHLIST% "%T1%"
		shift /1
	goto :PATHLISTLOOP
	:PATHLISTLOOPEND

	rem Append residual switches to SWITCHLIST
	:SWITCHLISTLOOP
		if {%1}=={} goto :SWITCHLISTLOOPEND
		set SWITCHLIST=%SWITCHLIST% %1
		shift /1
	goto :SWITCHLISTLOOP
	:SWITCHLISTLOOPEND

	rem Execute the NTBACKUP command
	echo -- ntbackup backup %PATHLIST% %NTBACKUPSW% %SWITCHLIST%
	ntbackup backup %PATHLIST% %NTBACKUPSW% %SWITCHLIST%

	rem Delete all temporary UNC drive maps
	for /l %%I in (1,1,%UNCCOUNT%) do popd
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem Additional procedures go here...

rem These must be the FINAL LINES in the script...
:DOSEXIT
echo This script requires Windows NT

rem /////////////////////////////////////////////////////////////////////////
